/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu;

import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.memory.Label;
import ru.ispras.microtesk.model.api.memory.Memory;

/**
 * The {@code PE} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PE extends ProcessingElement {
  public final Memory GPR;
  public final Memory PC;
  public final Memory M;

  private PE() {
    this.GPR = Memory.def(Memory.Kind.REG, "GPR", TypeDefs.BYTE, 16);
    this.PC = Memory.def(Memory.Kind.REG, "PC", TypeDefs.INDEX, 1);
    this.M = Memory.def(Memory.Kind.MEM, "M", TypeDefs.BYTE, 256);

    registerAll();
  }

  private PE(final PE other, final boolean shared) {
    this.GPR = other.GPR.copy();
    this.PC = other.PC.copy();
    this.M = other.M.copy();

    registerAll();
  }

  private void registerAll() {
    addStorage(GPR);
    addStorage(PC);
    addStorage(M);
  }

  @Override
  public ProcessingElement copy(final boolean shared) {
    return new PE(this, shared);
  }

  private static final class PEFactory implements Factory {
    @Override
    public PE create() {
      return new PE();
    }
  }

  public static Factory newFactory() {
    return new PEFactory();
  }
}
