/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.decoder;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.minimips.op.swc0;
import ru.ispras.microtesk.model.minimips.mode.RCOP0;
import ru.ispras.microtesk.model.api.Immediate;
import ru.ispras.microtesk.model.minimips.mode.REG;

/**
 * The {@code DecoderSwc0} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSwc0 extends DecoderItem {
  private static DecoderSwc0 instance = null;

  public static DecoderSwc0 get() {
    if (null == instance) {
      instance = new DecoderSwc0();
    }
    return instance;
  }

  private DecoderSwc0() {
    super(
        32,
        true,
        "11100000000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    RCOP0 cs = null;
    Immediate offset = null;
    REG address = null;

    if (!matchNextOpc(image, BitVector.valueOf("111000", 2, 6))) {
      return null;
    }

    address = (REG) readNextPrimitive(image, DecoderREG.get());
    if (null == address) {
      return null;
    }

    cs = (RCOP0) readNextPrimitive(image, DecoderRCOP0.get());
    if (null == cs) {
      return null;
    }

    offset = readNextImmediate(image, SHORT);

    return newResult(new swc0(cs, offset, address));
  }
}
