/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.minimips.PE;
import ru.ispras.microtesk.model.minimips.TempVars;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

public final class slti extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "slti",
          slti.class,
          null
          );
      addArgument("rt", REG.INFO);
      addArgument("rs", REG.INFO);
      addArgument("imm", SHORT);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final REG rt = (REG) getArgument("rt", args);
      final REG rs = (REG) getArgument("rs", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new slti(rt, rs, imm);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "slti",
          instruction.class,
          null
          );
      addArgument("rt", REG.INFO);
      addArgument("rs", REG.INFO);
      addArgument("imm", SHORT);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final REG rt = (REG) getArgument("rt", args);
      final REG rs = (REG) getArgument("rs", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new instruction(
        new slti(
          rt,
          rs,
          imm
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final REG rt;
  public final REG rs;
  public final Immediate imm;

  public slti(final REG rt, final REG rs, final Immediate imm) {
    assert REG.INFO.isSupported(rt);
    assert REG.INFO.isSupported(rs);
    assert SHORT.equals(imm.getType());

    this.rt = rt;
    this.rs = rs;
    this.imm = imm;

    addArgument("rt", rt);
    addArgument("rs", rs);
    addArgument("imm", imm);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("slti %s, %s, 0x%x", rt.syntax(vars__), rs.syntax(vars__), imm.access().load().bigIntegerValue(false));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("001010%s%s%s", rs.image(vars__), rt.image(vars__), imm.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    if ((rs.access(pe__, vars__).load().compareTo(Data.signExtend(WORD, imm.access().load())) < 0)) {
      rt.access(pe__, vars__).store(Data.valueOf(WORD, 0x1));
    } else {
      rt.access(pe__, vars__).store(Data.valueOf(WORD, 0x0));
    }
  }
}