/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc;

import ru.ispras.microtesk.model.api.ModelBuilder;
import ru.ispras.microtesk.model.powerpc.metadata.MetaModelFactory;
import ru.ispras.microtesk.model.powerpc.decoder.Decoder;
import ru.ispras.microtesk.model.powerpc.mode.*;
import ru.ispras.microtesk.model.powerpc.op.*;

/**
 * The {@code Model} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class Model extends ModelBuilder {
  public Model() {
    super(
        "powerpc",
        MetaModelFactory.newMetaModel(),
        Decoder.get(),
        PE.newFactory(),
        TempVars.newFactory()
        );

    addMode(R.INFO);
    addMode(FR.INFO);

    addOperation(nop.INFO);
    addOperation(lwa.INFO);
    addOperation(store_general.INFO);
    addOperation(stw.INFO);
    addOperation(load_general.INFO);
    addOperation(lwz.INFO);
    addOperation(stwu.INFO);
    addOperation(branch_general.INFO);
    addOperation(b.INFO);
    addOperation(ba.INFO);
    addOperation(bl.INFO);
    addOperation(bla.INFO);
    addOperation(add_general.INFO);
    addOperation(add.INFO);
    addOperation(add_d.INFO);
    addOperation(addo.INFO);
    addOperation(addo_d.INFO);
    addOperation(addi.INFO);
    addOperation(ori.INFO);
    addOperation(subf_general.INFO);
    addOperation(subf.INFO);
    addOperation(subf_d.INFO);
    addOperation(subfo.INFO);
    addOperation(subfo_d.INFO);
    addOperation(neg_general.INFO);
    addOperation(neg.INFO);
    addOperation(neg_d.INFO);
    addOperation(nego.INFO);
    addOperation(nego_d.INFO);
    addOperation(xor_general.INFO);
    addOperation(xor.INFO);
    addOperation(xor_d.INFO);
    addOperation(rlwinm_general.INFO);
    addOperation(rlwinm.INFO);
    addOperation(rlwinm_d.INFO);
    addOperation(slwi.INFO);
    addOperation(slwi_d.INFO);
    addOperation(srwi.INFO);
    addOperation(srwi_d.INFO);
    addOperation(extlwi.INFO);
    addOperation(extlwi_d.INFO);
    addOperation(extrwi.INFO);
    addOperation(extrwi_d.INFO);
    addOperation(rotlwi.INFO);
    addOperation(rotlwi_d.INFO);
    addOperation(rotrwi.INFO);
    addOperation(rotrwi_d.INFO);
    addOperation(clrlwi.INFO);
    addOperation(clrlwi_d.INFO);
    addOperation(clrrwi.INFO);
    addOperation(clrrwi_d.INFO);
    addOperation(clrlslwi.INFO);
    addOperation(clrlslwi_d.INFO);
    addOperation(or_general.INFO);
    addOperation(or.INFO);
    addOperation(or_d.INFO);
    addOperation(mr.INFO);
    addOperation(mr_d.INFO);
    addOperation(srawi_general.INFO);
    addOperation(srawi.INFO);
    addOperation(srawi_d.INFO);
    addOperation(instruction.INFO);
  }
}
