/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.powerpc.op.branch_general;
import ru.ispras.microtesk.model.api.Immediate;

/**
 * The {@code DecoderBranch_general} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBranch_general extends DecoderItem {
  private static DecoderBranch_general instance = null;

  public static DecoderBranch_general get() {
    if (null == instance) {
      instance = new DecoderBranch_general();
    }
    return instance;
  }

  private DecoderBranch_general() {
    super(
        32,
        true,
        "00000000000000000000000000010010",
        "00000000000000000000000000111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    Immediate LK_op = null;
    Immediate AA_op = null;
    Immediate LI_op = null;

    LK_op = readNextImmediate(image, BIT);

    AA_op = readNextImmediate(image, BIT);

    LI_op = readNextImmediate(image, Type.CARD(24));

    if (!matchNextOpc(image, BitVector.valueOf("010010", 2, 6))) {
      return null;
    }

    return newResult(new branch_general(LK_op, AA_op, LI_op));
  }
}
