/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.powerpc.op.nego_d;
import ru.ispras.microtesk.model.powerpc.mode.R;

/**
 * The {@code DecoderNego_d} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderNego_d extends DecoderItem {
  private static DecoderNego_d instance = null;

  public static DecoderNego_d get() {
    if (null == instance) {
      instance = new DecoderNego_d();
    }
    return instance;
  }

  private DecoderNego_d() {
    super(
        32,
        true,
        "10001011001000000000000000111110",
        "11111111111111110000000000111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R rd = null;
    R ra = null;

    if (!matchNextOpc(image, BitVector.valueOf("1", 2, 1))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("000101100", 2, 9))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("1", 2, 1))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("00000", 2, 5))) {
      return null;
    }

    ra = (R) readNextPrimitive(image, DecoderR.get());
    if (null == ra) {
      return null;
    }

    rd = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rd) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("111110", 2, 6))) {
      return null;
    }

    return newResult(new nego_d(rd, ra));
  }
}
