/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.powerpc.op.rlwinm_d;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.api.Immediate;

/**
 * The {@code DecoderRlwinm_d} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderRlwinm_d extends DecoderItem {
  private static DecoderRlwinm_d instance = null;

  public static DecoderRlwinm_d get() {
    if (null == instance) {
      instance = new DecoderRlwinm_d();
    }
    return instance;
  }

  private DecoderRlwinm_d() {
    super(
        32,
        true,
        "10000000000000000000000000101010",
        "10000000000000000000000000111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R ra = null;
    R rs = null;
    Immediate SH = null;
    Immediate MB = null;
    Immediate ME = null;

    if (!matchNextOpc(image, BitVector.valueOf("1", 2, 1))) {
      return null;
    }

    ME = readNextImmediate(image, SHIFT);

    MB = readNextImmediate(image, SHIFT);

    SH = readNextImmediate(image, SHIFT);

    ra = (R) readNextPrimitive(image, DecoderR.get());
    if (null == ra) {
      return null;
    }

    rs = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rs) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("101010", 2, 6))) {
      return null;
    }

    return newResult(new rlwinm_d(ra, rs, SH, MB, ME));
  }
}
