/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.mmu.sim;

import java.util.Map;
import java.util.HashMap;
import ru.ispras.microtesk.model.api.memory.MemoryDevice;
import ru.ispras.microtesk.mmu.model.api.*;

/**
 * The {@code Model} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class Model implements MmuModel {
  private final Map<String, BufferObserver> buffers;
  private final MemoryDevice device;
  private final MEM target;
  private final String targetId;

  public Model() {
    this.buffers = newBuffers();
    this.device = MMU.get();
    this.target = MEM.get();
    this.targetId = "MEM";
  }

  private static Map<String, BufferObserver> newBuffers() {
    final Map<String, BufferObserver> result = new HashMap<>();
    result.put("MEM", MEM.get());
    return result;
  }

  @Override
  public BufferObserver getBufferObserver(final String bufferId) {
    return buffers.get(bufferId);
  }

  @Override
  public MemoryDevice getMmuDevice() {
    return device;
  }

  @Override
  public String getStorageDeviceId() {
    return targetId;
  }

  @Override
  public void setStorageDevice(final MemoryDevice device) {
    target.setStorage(device);
  }
}
