/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.mmu.spec;

import java.util.Collections;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.basis.solver.integer.IntegerVariable;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBinding;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBuffer;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuExpression;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuStruct;

/**
 * The {@code MEM} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MEM extends MmuBuffer {
  private static MEM INSTANCE = null;

  public static MEM get() {
    if (null == INSTANCE) {
      INSTANCE = new MEM();
    }
    return INSTANCE;
  }

  private final PA pa = PA.get();

  public static final class Entry extends MmuStruct {
    public final IntegerVariable DATA;

    public Entry(final String name) {
      super(name);

      this.DATA = new IntegerVariable(name + ".DATA", 64);

      addField(DATA);
    }
  }
  public final IntegerVariable DATA;

  private MEM() {
    this("MEM");
  }

  private MEM(final String name) {
    super(
        name,
        Kind.UNMAPPED,
        1L,
        2147483648L,
        PA.get(),
        MmuExpression.empty(),
        MmuExpression.var(PA.get().value, 5, 35),
        MmuExpression.var(PA.get().value, 0, 4),
        Collections.<MmuBinding>emptyList(), // set up with setMatchBindings
        false,
        null
    );

    this.DATA = new IntegerVariable(name + ".DATA", 64);

    addField(DATA);
  }
}
