/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class addi extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "addi",
          addi.class,
          null
          );
      addArgument("rd", R.INFO);
      addArgument("ra", R.INFO);
      addArgument("simm", SHORT);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R ra = (R) getArgument("ra", args);
      final Immediate simm = (Immediate) getArgument("simm", args);

      return new addi(rd, ra, simm);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "addi",
          instruction.class,
          null
          );
      addArgument("rd", R.INFO);
      addArgument("ra", R.INFO);
      addArgument("simm", SHORT);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R ra = (R) getArgument("ra", args);
      final Immediate simm = (Immediate) getArgument("simm", args);

      return new instruction(
        new addi(
          rd,
          ra,
          simm
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rd;
  public final R ra;
  public final Immediate simm;

  public addi(final R rd, final R ra, final Immediate simm) {
    assert R.INFO.isSupported(rd);
    assert R.INFO.isSupported(ra);
    assert SHORT.equals(simm.getType());

    this.rd = rd;
    this.ra = ra;
    this.simm = simm;

    addArgument("rd", rd);
    addArgument("ra", ra);
    addArgument("simm", simm);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    vars__.OPCD.access().store(Data.valueOf(Type.CARD(6), 0x1c));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("addi %s, %s, %d", rd.syntax(vars__), ra.syntax(vars__), simm.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%16s%5s%5s%6s", simm.access().load().toString(), ra.image(vars__), rd.image(vars__), vars__.OPCD.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    ra.execute(pe__, vars__);
    if (vars__.gpr_reg_number.access().load().equals(Data.valueOf(Type.CARD(5), 0x0))) {
      vars__.temp.access().store(Data.valueOf(WORD, 0x0));
    } else {
      vars__.temp.access().store(ra.access(pe__, vars__).load());
    }
    rd.access(pe__, vars__).bitField(31, 0).store(Data.cast(WORD, Data.cast(INT, vars__.temp.access().load()).add(Data.cast(INT, Data.signExtend(INT, Data.cast(HWORD, simm.access().load()))))));
  }
}