/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class extlwi extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "extlwi",
          extlwi.class,
          null
          );
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("n", SHIFT);
      addArgument("k", SHIFT);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate n = (Immediate) getArgument("n", args);
      final Immediate k = (Immediate) getArgument("k", args);

      return new extlwi(ra, rs, n, k);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "extlwi",
          instruction.class,
          null
          );
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("n", SHIFT);
      addArgument("k", SHIFT);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate n = (Immediate) getArgument("n", args);
      final Immediate k = (Immediate) getArgument("k", args);

      return new instruction(
        new extlwi(
          ra,
          rs,
          n,
          k
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R ra;
  public final R rs;
  public final Immediate n;
  public final Immediate k;

  public extlwi(final R ra, final R rs, final Immediate n, final Immediate k) {
    assert R.INFO.isSupported(ra);
    assert R.INFO.isSupported(rs);
    assert SHIFT.equals(n.getType());
    assert SHIFT.equals(k.getType());

    this.ra = ra;
    this.rs = rs;
    this.n = n;
    this.k = k;

    addArgument("ra", ra);
    addArgument("rs", rs);
    addArgument("n", n);
    addArgument("k", k);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    vars__.Rc.access().store(Data.valueOf(BIT, 0x0));
    vars__.OPCD.access().store(Data.valueOf(Type.CARD(6), 0x2a));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("extlwi %s, %s, %d, %d", ra.syntax(vars__), rs.syntax(vars__), n.access().load().bigIntegerValue(), k.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%1s%5s%5s%5s%5s%5s%6s", vars__.Rc.access().load().toString(), n.access().load().subtract(Data.valueOf(SHIFT, 0x1)).toString(), "00000", k.access().load().toString(), ra.image(vars__), rs.image(vars__), vars__.OPCD.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new rlwinm(ra, rs, k, new Immediate(Data.valueOf(SHIFT, 0x0)), new Immediate(n.access().load().subtract(Data.valueOf(SHIFT, 0x1)))).execute(pe__, vars__);
  }
}