/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class rlwinm_d extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "rlwinm_d",
          rlwinm_d.class,
          null
          );
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("SH", SHIFT);
      addArgument("MB", SHIFT);
      addArgument("ME", SHIFT);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate SH = (Immediate) getArgument("SH", args);
      final Immediate MB = (Immediate) getArgument("MB", args);
      final Immediate ME = (Immediate) getArgument("ME", args);

      return new rlwinm_d(ra, rs, SH, MB, ME);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "rlwinm_d",
          instruction.class,
          null
          );
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("SH", SHIFT);
      addArgument("MB", SHIFT);
      addArgument("ME", SHIFT);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate SH = (Immediate) getArgument("SH", args);
      final Immediate MB = (Immediate) getArgument("MB", args);
      final Immediate ME = (Immediate) getArgument("ME", args);

      return new instruction(
        new rlwinm_d(
          ra,
          rs,
          SH,
          MB,
          ME
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R ra;
  public final R rs;
  public final Immediate SH;
  public final Immediate MB;
  public final Immediate ME;

  public rlwinm_d(final R ra, final R rs, final Immediate SH, final Immediate MB, final Immediate ME) {
    assert R.INFO.isSupported(ra);
    assert R.INFO.isSupported(rs);
    assert SHIFT.equals(SH.getType());
    assert SHIFT.equals(MB.getType());
    assert SHIFT.equals(ME.getType());

    this.ra = ra;
    this.rs = rs;
    this.SH = SH;
    this.MB = MB;
    this.ME = ME;

    addArgument("ra", ra);
    addArgument("rs", rs);
    addArgument("SH", SH);
    addArgument("MB", MB);
    addArgument("ME", ME);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    vars__.Rc.access().store(Data.valueOf(BIT, 0x1));
    vars__.OPCD.access().store(Data.valueOf(Type.CARD(6), 0x2a));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("rlwinm. %s, %s, %s, %s, %s", ra.syntax(vars__), rs.syntax(vars__), SH.access().load().toString(), MB.access().load().toString(), ME.access().load().toString());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%1s%5s%5s%5s%5s%5s%6s", vars__.Rc.access().load().toString(), ME.access().load().toString(), MB.access().load().toString(), SH.access().load().toString(), ra.image(vars__), rs.image(vars__), vars__.OPCD.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new rlwinm_general(new Immediate(vars__.Rc.access()), ra, rs, SH, MB, ME).execute(pe__, vars__);
  }
}