/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class srawi_d extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "srawi_d",
          srawi_d.class,
          null
          );
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("SH", SHIFT);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate SH = (Immediate) getArgument("SH", args);

      return new srawi_d(ra, rs, SH);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "srawi_d",
          instruction.class,
          null
          );
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("SH", SHIFT);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate SH = (Immediate) getArgument("SH", args);

      return new instruction(
        new srawi_d(
          ra,
          rs,
          SH
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R ra;
  public final R rs;
  public final Immediate SH;

  public srawi_d(final R ra, final R rs, final Immediate SH) {
    assert R.INFO.isSupported(ra);
    assert R.INFO.isSupported(rs);
    assert SHIFT.equals(SH.getType());

    this.ra = ra;
    this.rs = rs;
    this.SH = SH;

    addArgument("ra", ra);
    addArgument("rs", rs);
    addArgument("SH", SH);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    vars__.Rc.access().store(Data.valueOf(BIT, 0x1));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("srawi. %s", new srawi_general(new Immediate(vars__.Rc.access()), ra, rs, SH).syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s", new srawi_general(new Immediate(vars__.Rc.access()), ra, rs, SH).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new srawi_general(new Immediate(vars__.Rc.access()), ra, rs, SH).execute(pe__, vars__);
  }
}