/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.decoder;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.x86.op.MOV_R8IMM8;
import ru.ispras.microtesk.model.x86.mode.R8;
import ru.ispras.microtesk.model.x86.mode.IMM8;

/**
 * The {@code DecoderMOV_R8IMM8} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderMOV_R8IMM8 extends DecoderItem {
  private static DecoderMOV_R8IMM8 instance = null;

  public static DecoderMOV_R8IMM8 get() {
    if (null == instance) {
      instance = new DecoderMOV_R8IMM8();
    }
    return instance;
  }

  private DecoderMOV_R8IMM8() {
    super(
        24,
        true,
        "101100001100100000000000",
        "111110001111100000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R8 dst = null;
    IMM8 src = null;

    if (!matchNextOpc(image, BitVector.valueOf("10110", 2, 5))) {
      return null;
    }

    dst = (R8) readNextPrimitive(image, DecoderR8.get());
    if (null == dst) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("11001", 2, 5))) {
      return null;
    }

    dst = (R8) readNextPrimitive(image, DecoderR8.get());
    if (null == dst) {
      return null;
    }

    src = (IMM8) readNextPrimitive(image, DecoderIMM8.get());
    if (null == src) {
      return null;
    }

    return newResult(new MOV_R8IMM8(dst, src));
  }
}
