#
# MicroTESK PowerPC Edition
#
# Copyright (c) 2016 Institute for System Programming of the Russian Academy of Sciences
# All Rights Reserved
#
# Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
# 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
# http://www.ispras.ru
#

require_relative 'powerpc_base'

#
# Description:
#
# This small tests for MMU instructions.
#

class InstructionMMU < PowerPCBaseTemplate

  def run
    trace "Run MMU instruction:"
    trace "\nPowerPC Load/Store:\n"
    
    addi r1, r0, 0x0fff
    stwu r1, -0x30, r1
    trace "r1 = %x", gpr_observer(1)
    addi r2, r0, 0x123
    addi r5, r0, 0x0f00

    stw r2, 0x0, r1
    trace "r2 = %x", gpr_observer(2)
    stw r5, 0x4, r1
    trace "r5 = %x", gpr_observer(5)

    lwz r3, 0x0, r1
    trace "r3 = %x", gpr_observer(3)
    lwz r4, 0x4, r1
    trace "r4 = %x", gpr_observer(4)
  end

end